# git-reset(1) Manual Page

## NAME

git-reset - Reset current HEAD to the specified state

## SYNOPSIS

git reset [--mixed | --soft | --hard | --merge] [-q] [<commit>] git reset [-q] [<commit>] [--] <paths>… git reset --patch [<commit>] [--] [<paths>…]

## DESCRIPTION

Sets the current head to the specified commit and optionally resets the index and working tree to match.

This command is useful if you notice some small error in a recent commit (or set of commits) and want to redo that part without showing the undo in the history.

If you want to undo a commit other than the latest on a branch, git-revert(1) is your friend.

The second and third forms with paths and/or --patch are used to revert selected paths in the index from a given commit, without moving HEAD.

## OPTIONS

--mixed

  Resets the index but not the working tree (i.e., the changed files are preserved but not marked for commit) and reports what has not been updated. This is the default action.

--soft

  Does not touch the index file nor the working tree at all, but requires them to be in a good order. This leaves all your changed files "Changes to be committed", as git-status would put it.

--hard

  Matches the working tree and index to that of the tree being switched to. Any changes to tracked files in the working tree since <commit> are lost.

--merge

  Resets the index to match the tree recorded by the named commit, and updates the files that are different between the named commit and the current commit in the working tree.

-p
--patch

  Interactively select hunks in the difference between the index and <commit> (defaults to HEAD). The chosen hunks are applied in reverse to the index.

  This means that `git reset -p` is the opposite of `git add -p` (see git-add(1)).

-q

  Be quiet, only report errors.

<commit>

  Commit to make the current HEAD. If not given defaults to HEAD.

## Examples

Undo a commit and redo

      $ git commit ...
      $ git reset --soft HEAD^      (1)
      $ edit                        (2)
      $ git commit -a -c ORIG_HEAD  (3)

  1. This is most often done when you remembered what you just committed is incomplete, or you misspelled your commit message, or both. Leaves working tree as it was before "reset".

  2. Make corrections to working tree files.

  3. "reset" copies the old head to .git/ORIG_HEAD; redo the commit by starting with its log message. If you do not need to edit the message further, you can give -C option instead.

     See also the --amend option to git-commit(1).

Undo commits permanently

      $ git commit ...
      $ git reset --hard HEAD~3   (1)

  1. The last three commits (HEAD, HEAD^, and HEAD~2) were bad and you do not want to ever see them again. Do not do this if you have already given these commits to somebody else. (See the "RECOVERING FROM UPSTREAM REBASE" section in git-rebase(1) for the implications of doing so.)

Undo a commit, making it a topic branch

      $ git branch topic/wip     (1)
      $ git reset --hard HEAD~3  (2)
      $ git checkout topic/wip   (3)

  1. You have made some commits, but realize they were premature to be in the "master" branch. You want to continue polishing them in a topic branch, so create "topic/wip" branch off of the current HEAD.

  2. Rewind the master branch to get rid of those three commits.

  3. Switch to "topic/wip" branch and keep working.

Undo add

      $ edit                                     (1)
      $ git add frotz.c filfre.c
      $ mailx                                    (2)
      $ git reset                                (3)
      $ git pull git://info.example.com/ nitfol  (4)

  1. You are happily working on something, and find the changes in these files are in good order. You do not want to see them when you run "git diff", because you plan to work on other files and changes with these files are distracting.

  2. Somebody asks you to pull, and the changes sounds worthy of merging.

  3. However, you already dirtied the index (i.e. your index does not match the HEAD commit). But you know the pull you are going to make does not affect frotz.c nor filfre.c, so you revert the index changes for these two files. Your changes in working tree remain there.

  4. Then you can pull and merge, leaving frotz.c and filfre.c changes still in the working tree.

Undo a merge or pull

      $ git pull                         (1)
      Auto-merging nitfol
      CONFLICT (content): Merge conflict in nitfol
      Automatic merge failed; fix conflicts and then commit the result.
      $ git reset --hard                 (2)
      $ git pull . topic/branch          (3)
      Updating from 41223... to 13134...
      Fast forward
      $ git reset --hard ORIG_HEAD       (4)

  1. Try to update from the upstream resulted in a lot of conflicts; you were not ready to spend a lot of time merging right now, so you decide to do that later.

  2. "pull" has not made merge commit, so "git reset --hard" which is a synonym for "git reset --hard HEAD" clears the mess from the index file and the working tree.

  3. Merge a topic branch into the current branch, which resulted in a fast forward.

  4. But you decided that the topic branch is not ready for public consumption yet. "pull" or "merge" always leaves the original tip of the current branch in ORIG_HEAD, so resetting hard to it brings your index file and the working tree back to that state, and resets the tip of the branch to that commit.

Undo a merge or pull inside a dirty work tree

      $ git pull                         (1)
      Auto-merging nitfol
      Merge made by recursive.
       nitfol                |   20 +++++----
       ...
      $ git reset --merge ORIG_HEAD      (2)

  1. Even if you may have local modifications in your working tree, you can safely say "git pull" when you know that the change in the other branch does not overlap with them.

  2. After inspecting the result of the merge, you may find that the change in the other branch is unsatisfactory. Running "git reset --hard ORIG_HEAD" will let you go back to where you were, but it will discard your local changes, which you do not want. "git reset --merge" keeps your local changes.

Interrupted workflow

  Suppose you are interrupted by an urgent fix request while you are in the middle of a large change. The files in your working tree are not in any shape to be committed yet, but you need to get to the other branch for a quick bugfix.

      $ git checkout feature ;# you were working in "feature" branch and
      $ work work work       ;# got interrupted
      $ git commit -a -m "snapshot WIP"                 (1)
      $ git checkout master
      $ fix fix fix
      $ git commit ;# commit with real log
      $ git checkout feature
      $ git reset --soft HEAD^ ;# go back to WIP state  (2)
      $ git reset                                       (3)

  1. This commit will get blown away so a throw-away log message is OK.

  2. This removes the WIP commit from the commit history, and sets your working tree to the state just before you made that snapshot.

  3. At this point the index file still has all the WIP changes you committed as snapshot WIP. This updates the index to show your WIP files as uncommitted.

     See also git-stash(1).

Reset a single file in the index

  Suppose you have added a file to your index, but later decide you do not want to add it to your commit. You can remove the file from the index while keeping your changes with git reset.

      $ git reset -- frotz.c                      (1)
      $ git commit -m "Commit files in index"     (2)
      $ git add frotz.c                           (3)

  1. This removes the file from the index while keeping it in the working directory.

  2. This commits all other changes in the index.

  3. Adds the file to the index again.

## Author

Written by Junio C Hamano <gitster@pobox.com> and Linus Torvalds <torvalds@osdl.org>

## Documentation

Documentation by Junio C Hamano and the git-list <git@vger.kernel.org>.

## GIT

Part of the git(1) suite